
#ifdef __cplusplus
extern "C" {
#endif

#pragma once


#include "hgdalType.h"

#include "STDDeletable.h"

#include "stdcxxType.h"


#define OGRENVELOPE_DECL_VIRT(Type) \



#define OGRENVELOPE_DECL_NONVIRT(Type) \
Type##_p Type##_newOGREnvelope (  );


#define OGRENVELOPE_DECL_ACCESSOR(Type) \
double Type##_MinX_get ( Type##_p p );\
void Type##_MinX_set ( Type##_p p, double x );\
double Type##_MaxX_get ( Type##_p p );\
void Type##_MaxX_set ( Type##_p p, double x );\
double Type##_MinY_get ( Type##_p p );\
void Type##_MinY_set ( Type##_p p, double x );\
double Type##_MaxY_get ( Type##_p p );\
void Type##_MaxY_set ( Type##_p p, double x );


#define OGRENVELOPE_DEF_VIRT(Type) \



#define OGRENVELOPE_DEF_NONVIRT(Type) \
Type##_p Type##_newOGREnvelope (  ) {\
Type* newp=new Type();return from_nonconst_to_nonconst<Type##_t, Type>(newp);\
}


#define OGRENVELOPE_DEF_ACCESSOR(Type) \
double Type##_MinX_get ( Type##_p p ) {\
return (from_nonconst_to_nonconst<Type, Type##_t>(p))->MinX;\
}\
void Type##_MinX_set ( Type##_p p, double x ) {\
((from_nonconst_to_nonconst<Type, Type##_t>(p))->MinX)=x;\
}\
double Type##_MaxX_get ( Type##_p p ) {\
return (from_nonconst_to_nonconst<Type, Type##_t>(p))->MaxX;\
}\
void Type##_MaxX_set ( Type##_p p, double x ) {\
((from_nonconst_to_nonconst<Type, Type##_t>(p))->MaxX)=x;\
}\
double Type##_MinY_get ( Type##_p p ) {\
return (from_nonconst_to_nonconst<Type, Type##_t>(p))->MinY;\
}\
void Type##_MinY_set ( Type##_p p, double x ) {\
((from_nonconst_to_nonconst<Type, Type##_t>(p))->MinY)=x;\
}\
double Type##_MaxY_get ( Type##_p p ) {\
return (from_nonconst_to_nonconst<Type, Type##_t>(p))->MaxY;\
}\
void Type##_MaxY_set ( Type##_p p, double x ) {\
((from_nonconst_to_nonconst<Type, Type##_t>(p))->MaxY)=x;\
}


DELETABLE_DECL_VIRT(OGREnvelope)
OGRENVELOPE_DECL_VIRT(OGREnvelope)
OGRENVELOPE_DECL_NONVIRT(OGREnvelope)
OGRENVELOPE_DECL_ACCESSOR(OGREnvelope)

#ifdef __cplusplus
}
#endif

