{-# LANGUAGE FlexibleInstances, FlexibleContexts, TypeFamilies,
  MultiParamTypeClasses, OverlappingInstances, IncoherentInstances
  #-}
module GDAL.OGRCurvePolygon.Cast where
import Foreign.Ptr
import FFICXX.Runtime.Cast
import System.IO.Unsafe
import GDAL.OGRCurvePolygon.RawType
import GDAL.OGRCurvePolygon.Interface

instance (IOGRCurvePolygon a, FPtr a) =>
         Castable (a) (Ptr RawOGRCurvePolygon)
         where
        cast x f = f (castPtr (get_fptr x))
        uncast x f = f (cast_fptr_to_obj (castPtr x))

instance () => Castable (OGRCurvePolygon) (Ptr RawOGRCurvePolygon)
         where
        cast x f = f (castPtr (get_fptr x))
        uncast x f = f (cast_fptr_to_obj (castPtr x))
