{-# LANGUAGE ForeignFunctionInterface, TypeFamilies,
  MultiParamTypeClasses, FlexibleInstances, TypeSynonymInstances,
  EmptyDataDecls, ExistentialQuantification, ScopedTypeVariables #-}
module GDAL.OGRFeature.RawType where
import Foreign.Ptr
import FFICXX.Runtime.Cast

data RawOGRFeature

newtype OGRFeature = OGRFeature (Ptr RawOGRFeature)
                       deriving (Eq, Ord, Show)

instance () => FPtr (OGRFeature) where
        type Raw OGRFeature = RawOGRFeature
        get_fptr (OGRFeature ptr) = ptr
        cast_fptr_to_obj = OGRFeature
