{-# LANGUAGE FlexibleInstances, FlexibleContexts, TypeFamilies,
  MultiParamTypeClasses, OverlappingInstances, IncoherentInstances
  #-}
module GDAL.OGRFeatureDefn.Cast where
import Foreign.Ptr
import FFICXX.Runtime.Cast
import System.IO.Unsafe
import GDAL.OGRFeatureDefn.RawType
import GDAL.OGRFeatureDefn.Interface

instance (IOGRFeatureDefn a, FPtr a) =>
         Castable (a) (Ptr RawOGRFeatureDefn)
         where
        cast x f = f (castPtr (get_fptr x))
        uncast x f = f (cast_fptr_to_obj (castPtr x))

instance () => Castable (OGRFeatureDefn) (Ptr RawOGRFeatureDefn)
         where
        cast x f = f (castPtr (get_fptr x))
        uncast x f = f (cast_fptr_to_obj (castPtr x))
