
#include "MacroPatternMatch.h"

#include "HGDALOGRLayer.h"

#include "HGDALGDALMajorObject.h"

#include "gdal_priv.h"

#include "HGDALGDALDataset.h"



#define CHECKPROTECT(x,y) FXIS_PAREN(IS_ ## x ## _ ## y ## _PROTECTED)

#define TYPECASTMETHOD(cname,mname,oname) \
  FXIIF( CHECKPROTECT(cname,mname) ) ( \
  (from_nonconst_to_nonconst<oname,cname ## _t>), \
  (from_nonconst_to_nonconst<cname,cname ## _t>) )

GDALMAJOROBJECT_DEF_VIRT(GDALDataset)
DELETABLE_DEF_VIRT(GDALDataset)
GDALDATASET_DEF_VIRT(GDALDataset)
GDALDATASET_DEF_NONVIRT(GDALDataset)
GDALDATASET_DEF_ACCESSOR(GDALDataset)

