
#include "MacroPatternMatch.h"

#include "STDDeletable.h"

#include "ogr_core.h"

#include "HGDALOGREnvelope.h"



#define CHECKPROTECT(x,y) FXIS_PAREN(IS_ ## x ## _ ## y ## _PROTECTED)

#define TYPECASTMETHOD(cname,mname,oname) \
  FXIIF( CHECKPROTECT(cname,mname) ) ( \
  (from_nonconst_to_nonconst<oname,cname ## _t>), \
  (from_nonconst_to_nonconst<cname,cname ## _t>) )

DELETABLE_DEF_VIRT(OGREnvelope)
OGRENVELOPE_DEF_VIRT(OGREnvelope)
OGRENVELOPE_DEF_NONVIRT(OGREnvelope)
OGRENVELOPE_DEF_ACCESSOR(OGREnvelope)

