
#include "MacroPatternMatch.h"

#include "HGDALOGRGeometryCollection.h"

#include "ogr_geometry.h"

#include "HGDALOGRMultiSurface.h"



#define CHECKPROTECT(x,y) FXIS_PAREN(IS_ ## x ## _ ## y ## _PROTECTED)

#define TYPECASTMETHOD(cname,mname,oname) \
  FXIIF( CHECKPROTECT(cname,mname) ) ( \
  (from_nonconst_to_nonconst<oname,cname ## _t>), \
  (from_nonconst_to_nonconst<cname,cname ## _t>) )

OGRGEOMETRYCOLLECTION_DEF_VIRT(OGRMultiSurface)
OGRGEOMETRY_DEF_VIRT(OGRMultiSurface)
DELETABLE_DEF_VIRT(OGRMultiSurface)
OGRMULTISURFACE_DEF_VIRT(OGRMultiSurface)
OGRMULTISURFACE_DEF_NONVIRT(OGRMultiSurface)
OGRMULTISURFACE_DEF_ACCESSOR(OGRMultiSurface)

