
#include "MacroPatternMatch.h"

#include "HGDALOGRLinearRing.h"

#include "HGDALOGRCurvePolygon.h"

#include "ogr_geometry.h"

#include "HGDALOGRPolygon.h"



#define CHECKPROTECT(x,y) FXIS_PAREN(IS_ ## x ## _ ## y ## _PROTECTED)

#define TYPECASTMETHOD(cname,mname,oname) \
  FXIIF( CHECKPROTECT(cname,mname) ) ( \
  (from_nonconst_to_nonconst<oname,cname ## _t>), \
  (from_nonconst_to_nonconst<cname,cname ## _t>) )

OGRCURVEPOLYGON_DEF_VIRT(OGRPolygon)
OGRSURFACE_DEF_VIRT(OGRPolygon)
OGRGEOMETRY_DEF_VIRT(OGRPolygon)
DELETABLE_DEF_VIRT(OGRPolygon)
OGRPOLYGON_DEF_VIRT(OGRPolygon)
OGRPOLYGON_DEF_NONVIRT(OGRPolygon)
OGRPOLYGON_DEF_ACCESSOR(OGRPolygon)

