{-# LANGUAGE ForeignFunctionInterface, InterruptibleFFI #-}
module GDAL.OGREnvelope.FFI where
import Data.Word
import Data.Int
import Foreign.C
import Foreign.Ptr
import GDAL.OGREnvelope.RawType
import GDAL.OGREnvelope.RawType

foreign import ccall interruptible
               "HGDALOGREnvelope.h OGREnvelope_delete" c_ogrenvelope_delete ::
               Ptr RawOGREnvelope -> IO ()

foreign import ccall interruptible
               "HGDALOGREnvelope.h OGREnvelope_newOGREnvelope"
               c_ogrenvelope_newogrenvelope :: IO (Ptr RawOGREnvelope)

foreign import ccall interruptible "OGREnvelope_MinX_get"
               c_ogrenvelope_minx_get :: Ptr RawOGREnvelope -> IO CDouble

foreign import ccall interruptible "OGREnvelope_MinX_set"
               c_ogrenvelope_minx_set :: Ptr RawOGREnvelope -> CDouble -> IO ()

foreign import ccall interruptible "OGREnvelope_MaxX_get"
               c_ogrenvelope_maxx_get :: Ptr RawOGREnvelope -> IO CDouble

foreign import ccall interruptible "OGREnvelope_MaxX_set"
               c_ogrenvelope_maxx_set :: Ptr RawOGREnvelope -> CDouble -> IO ()

foreign import ccall interruptible "OGREnvelope_MinY_get"
               c_ogrenvelope_miny_get :: Ptr RawOGREnvelope -> IO CDouble

foreign import ccall interruptible "OGREnvelope_MinY_set"
               c_ogrenvelope_miny_set :: Ptr RawOGREnvelope -> CDouble -> IO ()

foreign import ccall interruptible "OGREnvelope_MaxY_get"
               c_ogrenvelope_maxy_get :: Ptr RawOGREnvelope -> IO CDouble

foreign import ccall interruptible "OGREnvelope_MaxY_set"
               c_ogrenvelope_maxy_set :: Ptr RawOGREnvelope -> CDouble -> IO ()
