{-# LANGUAGE ForeignFunctionInterface, TypeFamilies,
  MultiParamTypeClasses, FlexibleInstances, TypeSynonymInstances,
  EmptyDataDecls, ExistentialQuantification, ScopedTypeVariables #-}
module GDAL.OGRLayer.RawType where
import Foreign.Ptr
import FFICXX.Runtime.Cast

data RawOGRLayer

newtype OGRLayer = OGRLayer (Ptr RawOGRLayer)
                     deriving (Eq, Ord, Show)

instance () => FPtr (OGRLayer) where
        type Raw OGRLayer = RawOGRLayer
        get_fptr (OGRLayer ptr) = ptr
        cast_fptr_to_obj = OGRLayer
