{-# LANGUAGE EmptyDataDecls, ExistentialQuantification,
  FlexibleContexts, FlexibleInstances, ForeignFunctionInterface,
  MultiParamTypeClasses, ScopedTypeVariables, TypeFamilies,
  TypeSynonymInstances #-}
module GDAL.OGRLineString.Interface where
import Data.Word
import Data.Int
import Foreign.C
import Foreign.Ptr
import FFICXX.Runtime.Cast
import GDAL.OGRLineString.RawType
import GDAL.OGRSimpleCurve.Interface

class (IOGRSimpleCurve a) => IOGRLineString a where

upcastOGRLineString ::
                    forall a . (FPtr a, IOGRLineString a) => a -> OGRLineString
upcastOGRLineString h
  = let fh = get_fptr h
        fh2 :: Ptr RawOGRLineString = castPtr fh
      in cast_fptr_to_obj fh2

downcastOGRLineString ::
                      forall a . (FPtr a, IOGRLineString a) => OGRLineString -> a
downcastOGRLineString h
  = let fh = get_fptr h
        fh2 = castPtr fh
      in cast_fptr_to_obj fh2
