{-# LANGUAGE ForeignFunctionInterface, TypeFamilies,
  MultiParamTypeClasses, FlexibleInstances, TypeSynonymInstances,
  EmptyDataDecls, ExistentialQuantification, ScopedTypeVariables #-}
module GDAL.OGRMultiSurface.RawType where
import Foreign.Ptr
import FFICXX.Runtime.Cast

data RawOGRMultiSurface

newtype OGRMultiSurface = OGRMultiSurface (Ptr RawOGRMultiSurface)
                            deriving (Eq, Ord, Show)

instance () => FPtr (OGRMultiSurface) where
        type Raw OGRMultiSurface = RawOGRMultiSurface
        get_fptr (OGRMultiSurface ptr) = ptr
        cast_fptr_to_obj = OGRMultiSurface
